#!/bin/bash

# This script only check the ip address is standard IPv4 or not. Ignore IPv6.

# 10.0.0.0      -       10.255.255.255      (10/8 prefix)
# 172.16.0.0    -       172.31.255.255      (172.16/12 prefix)
# 192.168.0.0   -       192.168.255.255     (192.168/16 prefix)

# DOCKER0_NETADDR=$(ip -4 a | sed -n -r '/docker0/{/inet/ {s/inet(.*)\sbrd(.*)/\1/g;s/\s//g;s/\/.*//g;p}}')
# DOCKERGW_NETADDR=$(ip -4 a | sed -n -r '/docker_gwbridge/{/inet/ {s/inet(.*)\sbrd(.*)/\1/g;s/\s//g;s/\/.*//g;p}}')

NETADDR=$(ip -4 a | sed -n -r '/'"$1"'/{/inet/ {s/inet(.*)\sbrd(.*)/\1/g;s/\s//g;s/\/.*//g;p}}')

function and() {
    bit1=$(echo "ibase=10;obase=2;$1" | bc)
    bit2=$(echo "ibase=10;obase=2;$2" | bc)
    len1=${#bit1}
    len2=${#bit2}
    if [ "$len1" -gt "$len2" ]; then
        len=$len1
        bit2=$(printf "%0${len}d" $bit2)
    elif [ "$len1" -lt "$len2" ]; then
        len=$len2
        bit1=$(printf "%0${len}d" $bit1)
    else
        len=$len1
    fi

    for ((i = 1; i <= len; i++)); do
        b1=${bit1:0-$i:1}
        b2=${bit2:0-$i:1}
        if [ $b1 -eq 1 ] && [ $b2 -eq 1 ]; then
            b=1
        else
            b=0
        fi
        result=$(echo "$b""$result")
    done
    result=$(echo "obase=10;ibase=2;$result" | bc)
    echo $result
}

function check_is_private_or {
    _net_addr_array=($(echo $1 | awk -F '.' 'END{for(i=1;i<=NF;i++){print $i}}'))
    if [ ${_net_addr_array[0]} == 10 ]; then
        # echo "Assigned address is private."
        return 0
    elif [ ${_net_addr_array[0]} == 172 -a $(and ${_net_addr_array[1]} 240) == 16 ]; then
        # echo "Assigned address is private."
        return 0
    elif [ ${_net_addr_array[0]} == 192 -a ${_net_addr_array[1]} == 168 ]; then
        # echo "Assigned address is private."
        return 0
    else
        # echo "Assigned address: $1 is not private."
        return 1
    fi
}

check_is_private_or $NETADDR && \
echo "{\"checkValue\": \"true\",\"checkStatus\": \"OK\", \"msg\": \"$1 is private\"}" || \
echo "{\"checkValue\": \"false\",\"checkStatus\": \"fail\", \"msg\": \"$1 is not private.\"}"
